/*
** tutor12.prg
*/

new;
library PDE2D,pgraph;
PDE2Dset;

#include elliptic.inc;

rndseed 123;

output file = tutor12.out reset;

call PDE2D(&aProc,&bProc,&cProc,&dProc,&eProc,&fProc,&gProc,0,
           &InitialGuessSolution,
           &xminBound,&xmaxBound,&yminBound,&ymaxBound,
           0,0,0,0);

xmin = 0; xmax = 1; Nx = 21;
ymin = 0; ymax = 1; Ny = 21;
tmin = 0; tmax = 0.425; Nt = 101;

_Hopscotch_Methods = {1,2}; /* left-right filling method
                                      &
                               ordered odd-even Hopscotch method */

_Hopscotch_Elliptic = 1;
_Hopscotch_SaveLastIter = 1;
_fcmptol = 1e-4;

call Hopscotch(tmin,tmax,Nt,xmin,xmax,Nx,ymin,ymax,Ny,"tutor12");

x = ExtractSolution("tutor12","x");
y = ExtractSolution("tutor12","y");
t = ExtractSolution("tutor12","t");

print; print "t vector = " t;

U = ExtractSolution("tutor12","t"|t);
sol = solutionProc(t,x,y);

output off;

graphset;
  _pdate = "";
  title("Relative numerical error (%)");
  xlabel("x");
  ylabel("y");
  ztics(0,1.5,0.5,5);
  graphprt("-c=1 -cf=tutor12.eps");
  surface(x',y',100*missrv((U-sol)'./miss(sol,0),0));
